;TIP1057.LSP:  THRU.LSP    Break Crossing Lines     (C)1994, Stan Kowalski

(defun etype (E)
   (setq E (Cdr (assoc 0 (entget (car E)))))
)

(defun askdist (R S / R S ANS)
   (setq ANS nil)
   (if (= R nil)
      (progn
         (while (or (= ANS "") (= ANS nil))
            (princ (strcat S ": "))
            (setq ANS (getdist))
         );end while
         (setq R ANS)
      );end progn
      (progn
         (princ (strcat S " <" (rtos R) ">: "))
         (setq ANS (getdist))
         (if (or (= ANS nil) (= ANS ""))
            (setq R R)
            (setq R ANS)
         )
      );end progn
   );end if
   R
);end function askdist

(defun C:THRU (/ CON CPE CPM ET ETE ETM IP HG)
   (setq CON (entsel "\nSelect line to remain continuous: "))
   (if (null CON)
      (prompt "\nI don't think you selected anything.")
      (progn
         (setq THRU_GAP (askdist THRU_GAP "\nGap spacing"))
         (if
            (or
               (= (etype CON) "POLYLINE")
               (= (etype CON) "LINE")
            )
            (progn
               (setvar "cmdecho" 0)
               (setvar "highlight" 0)
               (setq CPE (osnap (cadr CON) "endp")
                  CPM (osnap (cadr CON) "midp")
               )
               (setq ET (entsel "\nEntity passing thru: "))
               (while ET
                  (setq ETE (osnap (cadr ET) "endp")
                     ETM (osnap (cadr ET) "midp")
                  )
                  (setq IP (inters CPE CPM ETE ETM nil)
                     HG (/ thru_gap 2.0)
                  )
                  (command "break" (cadr ET) "F" (polar IP (angle ETE ETM) HG)
                     (polar IP (angle ETM ETE) HG)
                  );end command
                  (setq ET (entsel "\nEntity passing thru: "))
               );end while
            );end progn - work portion
            (prompt "Continuous entity not a line")
         );end if - continuous entity line or polyline
      );end progn - yes entity present
   );end if - continuous entity selected
   (setvar "cmdecho" 1)
   (setvar "highlight" 1)
   (princ)
);end command

